unit printout;

interface
         procedure printoutCALC;//vZʂ̃v^[ւ̏o
         procedure printoutdata;
         procedure printoutQuality;//olOto

implementation

uses conical_main,matdataread,Conical_calc,Graphics,Printers,SysUtils,Forms,drawing,Math;

var keisu:  double;//vgAEg{@PrintOut݂̂Ŏgp

procedure PCENTERLINE(Xpos,Ypos,r: Double);//S}
begin
  with Printer.Canvas do begin
    MoveTo(round(Xpos - r * 1.2 - 1),round(ypos));
    LineTo(round(Xpos + r * 1.2 + 1),round(ypos));
    MoveTo(round(Xpos),round(ypos - r * 1.2 - 1));
    LineTo(round(Xpos),round(ypos + r * 1.2 + 1));
  end;
end;

procedure PCIRCLE(Xpos,Ypos,r: Double; s,e: Double);//~}
var
  XT,YT,XB,YB,SX,SY,EX,EY  : integer;
begin
  r := r + 0.5;
  XT := round(Xpos - r);
  YT := round(Ypos + r);
  XB := round(Xpos + r);
  YB := round(Ypos - r);
  SX := round(Xpos + cos(s) * r);
  SY := round(Ypos - sin(s) * r);
  EX := round(Xpos + cos(e) * r);
  EY := round(Ypos - sin(e) * r);
  with Printer.Canvas do begin
    if  (XB - XT < 3) or (YT - YB < 3) then
      begin
        if XT = XB then XB := XB + 1;
        if YT = YB then YB := YB - 1;
        MoveTo(XT,YB);
        Lineto(XB,YB);
        Lineto(XB,YT);
        Lineto(XT,YT);
        Lineto(XT,YB);
      end
      else Arc(XT, YT, XB, YB, SX, SY, EX, EY);
  end;
end;

procedure PYA(YAXPOS,YAYPOS,Q: Double); //@ppx͉E
var
  XX, YY: integer;
  YAQ,QYAS,QYAE: Double;
  LENGYAS,LENGYAE,OFFYAS,OFFYAE: integer;
begin
  XX:= round(YAXPOS);
  YY:= round(YAYPOS);
  YAQ:= PI/12;
  QYAS := Q + YAQ;
  QYAE := Q - YAQ;
  if QYAS > PI * 2 then QYAS := QYAS - PI * 2;
  if QYAE > PI * 2 then QYAE := QYAE - PI * 2;
  if QYAS < 0 then QYAS := QYAS + PI * 2;
  if QYAE < 0 then QYAE := QYAE + PI * 2;
  LENGYAS := round(COS(QYAS) * 15 * keisu);
  LENGYAE := round(COS(QYAE) * 15 * keisu);
  OFFYAS := round(SIN(QYAS) * 15 * keisu);
  OFFYAE := round(SIN(QYAE) * 15 * keisu);
  with Printer.Canvas do begin
    MoveTo(XX,YY);
    Lineto(XX + LENGYAS,YY + OFFYAS);
    MoveTo(XX,YY);
    Lineto(XX + LENGYAE,YY + OFFYAE);
  end;
end;

procedure printoutQuality;//olOto
var
  Xscal,Yscal,Xpos,Ypos,x0,y0: integer;
  Xscalpich,Xsc,XXp: double;
  Yscalpich,Ysc,YYp: double;
begin
  Xscal := 400;
  Yscal := 250;
  x0 := 140;
  y0 := 350;
  with printer do begin
    if PageHeight > PageWidth then keisu := PageWidth / Form1.Width
                              else keisu := PageHeight / Form1.Width / PageWidth * PageHeight;
    with Canvas do begin
      Pen.Width := 1;
      Pen.Style := psSolid;
      Pen.color := clred;
      MoveTo(round(x0 * keisu), round(y0 * keisu - Yscal * keisu));
      LineTo(round(x0 * keisu), round(y0 * keisu));
      Pen.color := clblack;
      LineTo(round(x0 * keisu + Xscal * keisu), round(y0 * keisu));
      Pen.color := clblue;
      LineTo(round(x0 * keisu + Xscal * keisu), round(y0 * keisu - Yscal * keisu));
      //݃XP[
      Xscalpich := 0.05;
      if deltaMax > 0 then Xscalpich := 0.1;
      if deltaMax > 1 then Xscalpich := 0.2;
      if deltaMax > 2 then Xscalpich := 0.5;
      if deltaMax > 5 then Xscalpich := 1;
      if deltaMax > 10 then Xscalpich := 2;
      if deltaMax > 20 then Xscalpich := 5;
      if deltaMax > 50 then Xscalpich := 10;
      if deltaMax > 100 then Xscalpich := 20;
      if deltaMax > 200 then Xscalpich := 50;
      if deltaMax > 500 then Xscalpich := 100;
      Xsc := Xscal / deltaMax;
      XXp := Xscalpich;
      Pen.color := clgreen;
      Pen.Style := psdot;
      Font.Color := clBlack;
      Font.Height := round(12 * keisu);
      Repeat
        MoveTo(round(x0 * keisu) + round(XXp * Xsc * keisu), round(y0 * keisu));
        LineTo(round(x0 * keisu) + round(XXp * Xsc * keisu),round(y0 * keisu - Yscal * keisu));
        Textout(round(x0 * keisu) + round(XXp * Xsc * keisu - 10 * keisu),
                                      round(y0 * keisu + 2 * keisu),floatTostrF(XXp,ffFixed,5,1));
        XXp := XXp + Xscalpich;
      until deltaMax < XXp;
      Textout(round(x0 * keisu) + round(deltaMax * Xsc * keisu - 10 * keisu),
                                round(y0 * keisu + 13 * keisu),floatTostrF(deltaMax,ffFixed,5,1));
      //׏dXP[
      Yscalpich := 0.005;
      if Pmax > 0 then Yscalpich := 0.01;
      if Pmax > 0.1 then Yscalpich := 0.02;
      if Pmax > 0.2 then Yscalpich := 0.05;
      if Pmax > 0.5 then Yscalpich := 0.1;
      if Pmax > 1 then Yscalpich := 0.2;
      if Pmax > 2 then Yscalpich := 0.5;
      if Pmax > 5 then Yscalpich := 1;
      if Pmax > 10 then Yscalpich := 2;
      if Pmax > 20 then Yscalpich := 5;
      if Pmax > 50 then Yscalpich := 10;
      if Pmax > 100 then Yscalpich := 20;
      if Pmax > 200 then Yscalpich := 50;
      if Pmax > 500 then yscalpich := 100;
      if Pmax > 1000 then yscalpich := 200;
      if Pmax > 2000 then yscalpich := 500;
      Ysc := Yscal / Pmax;
      YYp := Yscalpich;
      Pen.color := clRed;
      Pen.Style := psSolid;
      Font.Color := clRed;
      Font.Height := round(12 * keisu);
      Repeat
        LL := floatTostrF(YYp,ffFixed,5,2);
        MoveTo(round(x0 * keisu), round(y0 * keisu) - round(YYp * Ysc * keisu));
        LineTo(round(x0 * keisu + Xscal * keisu),round(y0 * keisu) - round(YYp * Ysc * keisu));
        Textout(round(x0 * keisu - Printer.Canvas.TextWidth(LL) - 5 * keisu),
                                    round(y0 * keisu) - round(YYp * Ysc * keisu + 5 * keisu), LL);
        YYp := YYp + Yscalpich;
      until Pmax < YYp;

      Pen.Style := psSolid;
      Pen.color := clred;
      Pen.Width := 2;
      MoveTo(round(x0 * keisu), round(y0 * keisu));

      //׏d
      dashn := 0;
      Repeat
        D := D2 - (D2 - D1) / n * dashn;
        if stype and 1 = 1 then//sb`vZ
          begin
            //őaRC炎f̎R
            //H0 := dashn * pich;
            //׏d
            P := G * multiply(dia, 4) * (pich - dashd)/ 8/ D/ D/ D;
            //
            delta := n/(D2-D1)*(2*(multiply(D, 4)-multiply(D1, 4))/G/multiply(dia, 4)*P
                         +(pich-dashd)*(D2-D));
            //[̏CW
          end
          else                //sb`pvZ
          begin
            //őaRC炎f̎R
            //H0 := pi * pq * dashn * (D2 - (D2 - D1) * dashn / 2 / n);
            //׏d
            P := pi * multiply(dia, 4) * G / 8 / D / D * (pq - dashd / pi / D);
            //
            delta := n/(D2-D1)*(2*(multiply(D, 4)-multiply(D1, 4))/G/multiply(dia, 4)*P
                                                         +pi/2*pq*(D2*D2 -D*D)-dashd*(D2-D));
          end;
        Xpos := round(delta * XSc * keisu);
        Ypos := round(P * Ysc * keisu);
        LineTo(round(x0 * keisu) + Xpos, round(y0 * keisu) - Ypos);

        kappa := (4 * D/dia -1)/(4 * D/dia - 4) + 0.615/(D/dia);
        //C
        tau0 := 8 * D * P / pi / multiply(dia, 3);
        //C
        tau := tau0 * kappa;
        dashn := dashn + dashk;//Z
      until n < dashn;

      //XP[
      if fh0 > 0 then Yscalpich := 0.01;
      if fh0 > 0.1 then Yscalpich := 0.02;
      if fh0 > 0.2 then Yscalpich := 0.05;
      if fh0 > 0.5 then Yscalpich := 0.1;
      if fh0 > 1 then Yscalpich := 0.2;
      if fh0 > 2 then Yscalpich := 0.5;
      if fh0 > 5 then Yscalpich := 1;
      if fh0 > 10 then Yscalpich := 2;
      if fh0 > 20 then Yscalpich := 5;
      if fh0 > 50 then Yscalpich := 10;
      if fh0 > 100 then Yscalpich := 20;
      if fh0 > 200 then Yscalpich := 50;
      if fh0 > 500 then yscalpich := 100;
      if fh0 > 1000 then yscalpich := 200;
      if fh0 > 2000 then yscalpich := 500;
      Ysc := Yscal / fh0;//́AolR
      YYp := Yscalpich;
      Pen.Width := 1;
      Pen.color := clblue;
      Pen.Style := psdot;
      Font.Color := clblue;
      Font.Height := round(12 * keisu);
      Repeat
        MoveTo(round(x0 * keisu), round(y0 * keisu) - round(YYp * Ysc * keisu));
        LineTo(round(x0 * keisu + Xscal * keisu),round(y0 * keisu) - round(YYp * Ysc * keisu));
        Textout(round(x0 * keisu + Xscal * keisu + 3 * keisu),
           round(y0 * keisu) - round(YYp * Ysc * keisu + 5 * keisu),floatTostrF(YYp,ffFixed,5,1));
        YYp := YYp + Yscalpich;
      until fh0 < YYp;

      //ol̒ƝݗʃOt
      Pen.Style := psDash;
      Pen.color := clBlack;
      Pen.Width := 1;

      Xpos := 0;
      Ypos := round(fh0 * Ysc * keisu);
      MoveTo(round(x0 * keisu) + Xpos, round(y0 * keisu) - Ypos);
      Xpos := round(deltaMax * XSc * keisu);
      Ypos := round((fh0 - deltaMax) * Ysc * keisu);
      LineTo(round(x0 * keisu) + Xpos, round(y0 * keisu) - Ypos);

      Xpos := 0;
      Ypos := round(fh0 * Ysc * keisu) + 1;
      MoveTo(round(x0 * keisu) + Xpos, round(y0 * keisu) - Ypos);
      Xpos := round(deltaMax * XSc * keisu);
      Ypos := round((fh0 - deltaMax) * Ysc * keisu)+ 1;
      LineTo(round(x0 * keisu) + Xpos, round(y0 * keisu) - Ypos);

      Xpos := 0;
      Ypos := round(fh0 * Ysc * keisu) - 1;
      MoveTo(round(x0 * keisu) + Xpos, round(y0 * keisu) - Ypos);
      Xpos := round(deltaMax * XSc * keisu);
      Ypos := round((fh0 - deltaMax) * Ysc * keisu) - 1;
      LineTo(round(x0 * keisu) + Xpos, round(y0 * keisu) - Ypos);

      Font.Color := clBlack;
      Font.Height := round(15 * keisu);
      TextOut(round(x0 * keisu + 120 * keisu),  round(y0 * keisu + 30 * keisu),'olݗ mm');
      Font.Color := clRed;
      TextOut(round(x0 * keisu - 90 * keisu), round(y0 * keisu - 150 * keisu),'׏d m');
      Font.Color := clBlue;
      TextOut(round(x0 * keisu + 420 * keisu), round(y0 * keisu - 150 * keisu),'ol mm');
      Font.Color := clGreen;
      TextOut(round(50 * keisu),round(50 * keisu),'olݗʂƁA׏d̊֌W()');
      TextOut(round(150 * keisu),round(70 * keisu),'olݗʂƁAol̒̊֌W(j)\B');
      Font.Height := round(20 * keisu);
      Font.Color := clBlue;
      TextOut(round(100 * keisu),round(10 * keisu),'olOt');
    end;
  end;
end;

procedure printoutdata;//vZʏo
begin
  with Printer.Canvas do begin
    Font.Color := clBlack;
    textout(round(100 * keisu),round(440 * keisu),'a');//a
    textout(round(100 * keisu),round(460 * keisu),'ԋ߂lɊۂ߂L');//ԋ߂Ɋۂ߂
    textout(round(100 * keisu),round(480 * keisu),'sb`');//sb`
    if stype and 1 = 0 then
           textout(round(100 * keisu),round(500 * keisu),'sb`p@deg')//sb`p
      else textout(round(100 * keisu),round(500 * keisu),'sb`');//sb`

    textout(round(100 * keisu),round(520 * keisu),'R');//R
    textout(round(100 * keisu),round(540 * keisu),'Ӎő唼a');//Ӎő唼a
    textout(round(100 * keisu),round(560 * keisu),'Ӎŏa');//Ӎŏa
    textout(round(100 * keisu),round(580 * keisu),'RCSij');//RCSij
    textout(round(100 * keisu),round(600 * keisu),'RS');//RS
    textout(round(100 * keisu),round(620 * keisu),'(܂)');//
    textout(round(100 * keisu),round(640 * keisu),'e');//e
    textout(round(100 * keisu),round(660 * keisu),'ő剞');//ő剞
    textout(round(100 * keisu),round(680 * keisu),'');//
    textout(round(100 * keisu),round(700 * keisu),'ő׏d');//ő׏d
    textout(round(100 * keisu),round(720 * keisu),'w׏d');//w׏d

//make:   byte;//ޯ 0 0 w薳 1 wL ޯ 1 0 ΂˒萔 1 @ޯ 3 1 L
    if make and 6 = 0 then textout(round(100 * keisu),round(740 * keisu),'wol萔');
    if make and 6 = 2 then textout(round(100 * keisu),round(740 * keisu),'w薧()');
    if make and 6 = 4 then textout(round(100 * keisu),round(740 * keisu),'wL');
    textout(round(100 * keisu),round(760 * keisu),'w׏dol');

    textout(round(400 * keisu),round(440 * keisu),floatTostrF(dia,ffFixed,5,3));//a
    textout(round(400 * keisu),round(460 * keisu),floatTostrF(n,ffFixed,5,1));//ԋ߂Ɋۂ߂
    textout(round(400 * keisu),round(480 * keisu),floatTostrF(dashd,ffFixed,5,2));//sb`
    if stype and 1 = 0 then
          textout(round(400 * keisu),round(500 * keisu),floatTostrF(pq / pi * 180,ffFixed,6,3))//sb`p
      else textout(round(400 * keisu),round(500 * keisu),floatTostrF(pich,ffFixed,6,3));//sb`

    textout(round(400 * keisu),round(520 * keisu),floatTostrF(H0,ffFixed,6,2));//R
    textout(round(400 * keisu),round(540 * keisu),floatTostrF(Ro,ffFixed,6,2));//Ӎő唼a
    textout(round(400 * keisu),round(560 * keisu),floatTostrF(Ri,ffFixed,6,2));//Ӎŏa
    textout(round(400 * keisu),round(580 * keisu),floatTostrF(L,ffFixed,6,2));//RCSij
    textout(round(400 * keisu),round(600 * keisu),floatTostrF(fh0,ffFixed,6,2));//RS
    textout(round(400 * keisu),round(620 * keisu),floatTostrF(fh0 - delta,ffFixed,6,2));//
    textout(round(400 * keisu),round(640 * keisu),floatTostrF(T1,ffFixed,6,2));//e
    textout(round(400 * keisu),round(660 * keisu),floatTostrF(taumax,ffFixed,7,2));//ő剞
    textout(round(400 * keisu),round(680 * keisu),floatTostrF(n + 2,ffFixed,7,2));//
    textout(round(400 * keisu),round(700 * keisu),floatTostrF(P,ffFixed,7,2));//ő׏d
    textout(round(400 * keisu),round(720 * keisu),floatTostrF(Pin,ffFixed,7,2));//ő׏d
    if make and 6 = 0 then textout(round(400 * keisu),round(740 * keisu),floatTostrF(kin,ffFixed,7,2));
    if make and 6 = 2 then textout(round(400 * keisu),round(740 * keisu),floatTostrF(Hsin,ffFixed,7,2));
    if make and 6 = 4 then textout(round(400 * keisu),round(740 * keisu),floatTostrF(Nin,ffFixed,7,2));
    textout(round(400 * keisu),round(760 * keisu),floatTostrF(Pdelta,ffFixed,7,2));//olvZ
  end;
end;


procedure printoutCALC;//vZʂ̃v^[ւ̏o
var
//   pwidth: integer;
   non,Leng:              integer;
   Xpos,Ypos,XposB,YposB,XposS,YposS,XposE,YposE,Yposd: double;
   Lx0,Ly0,Lx1,Ly1:            integer;//W
   QL:                         double;//ڐpx

begin
  if Form1.PrintDialog1.Execute then else exit; //v^[ݒ肳ĂȂI
  Printer.BeginDoc;

  if stype and 1 = 0 then LL := 'sb`pvZ'
                     else LL := 'sb`vZ';
  with printer do begin
     if PageHeight > PageWidth then keisu := PageWidth / Form1.Width
        else keisu := PageHeight / Form1.Width / PageWidth * PageHeight;

    XposS := 0;
    YposS := 0;
    XposE := 0;
    YposE := 0;
    YposD := YposS;
    with Canvas do begin
      pen.width := 1;
      scale := Xwin / 5 * 3 / (Ro * 2 + dia);
      if ywin / 5 * 3 / fh0 < scale then scale := ywin / 5 * 3 / fh0;//XP[̐ݒ
      pen.color := clblack;
      pen.Style := psDashDot;
      moveTo(round(x0 * keisu), round((y0 + 10) * keisu));
      LineTo(round(x0 * keisu), round((y0 - fh0 * scale - 10) * keisu));
      pen.Style := psSolid;
      brush.style := bsClear;
      pen.color := clRed;
      Font.Height := round(20 * keisu);
      Font.Color := clBlack;
      Textout(round(100 * keisu),round(10 * keisu),LL);
      Font.Height := round(15 * keisu);
      //ӂ̐
      if stype and 2 = 2 then Xpos := (Ro + dia / 2) * scale * keisu
                         else Xpos := Ro * scale * keisu;
      moveTo(round(x0 * keisu - Xpos), round(y0 * keisu));
      if stype and 2 = 2 then Xpos := ((Ro + D2 / 2) / 2 + dia / 2) * scale * keisu
                         else Xpos := (Ro + D2 / 2) / 2 * scale * keisu;
      LineTo(round(x0 * keisu + Xpos), round(y0 * keisu));
      if (maked and 4 = 4) then //@}
        begin
          XposB := x0 * keisu- Xpos - 5 * keisu;//@⏕
          XposS := x0 * keisu - Xpos - 50 * keisu;
          YposS := y0 * keisu;
          pen.color := clBlack;
          moveTo(round(XposB), round(YposS));
          LineTo(round(XposS), round(YposS));
          PCIRCLE(XposS + 10 * keisu, YposS, 3 * keisu, 0, pi * 2);
          XposB := x0 * keisu + Xpos + 5 * keisu;//E@⏕
          XposE := x0 * keisu + Xpos + 50 * keisu;
          YposE := y0 * keisu;
          moveTo(round(XposB), round(YposE));
          LineTo(round(XposE), round(YposE));
          PCIRCLE(XposE - 10 * keisu, YposE, 3 * keisu, 0, pi * 2);
          pen.color := clRed;
        end;

      //̐̒Syшʒu
      if stype and 2 = 2 then Ypos := y0 * keisu - dia * (0.5 - tanmengl) * scale * keisu//RS tanmengl ͌
                         else Ypos := y0 * keisu - dia / 2  * scale * keisu;//RS 0 ͌
      Xpos := x0 * keisu - Ro * scale * keisu;
      //͂߈ʒu
      if stype and 2 = 2 then PCIRCLE(Xpos, Ypos, dia / 2  * scale * keisu,
                                    ArcSin((tanmengl - 0.5) / 0.5),pi - ArcSin((tanmengl - 0.5)) / 0.5)
                         else
                         begin
                          PCIRCLE(Xpos, Ypos, dia / 2  * scale * keisu, 0 ,pi * 2);
                          pen.Style := psDashdot;
                          PCENTERLINE(Xpos,Ypos,dia / 2 * scale * keisu);//S}
                         end;
      pen.Style := psSolid;
      if (maked and 4 = 4) then //a@}
        begin
          pen.color := clBlack;
          moveTo(round(x0 * keisu), round(y0 * keisu + 13 * keisu));
          LineTo(round(x0 * keisu), round(y0 * keisu + 70 * keisu));
          moveTo(round(Xpos), round(y0 * keisu + 5 * keisu));
          LineTo(round(Xpos), round(y0 * keisu + 70 * keisu));
          moveTo(round(x0 * keisu), round(y0 * keisu + 65 * keisu));
          LineTo(round(Xpos), round(y0 * keisu + 65 * keisu));
          PYA(x0 * keisu,y0 * keisu + 65 * keisu, pi);
          PYA(Xpos,y0 * keisu + 65 * keisu, 0);
          LL := floatTostrF(Ro,ffFixed,5,1);
          Leng := TextWidth(LL);
          TextOut(round(x0 * keisu - (x0 * keisu - xpos + Leng)/2),
                                                    round(y0 * keisu + 65 * keisu - 17 * keisu),LL);
          pen.color := clRed;
        end;

      //̂ODTavZ
      D := (Ro * 2 + D2) / 2;//ODT̔avZ
      Xpos := x0 * keisu + D / 2 * scale * keisu;
      if stype and 2 = 2 then Ypos := y0 * keisu
                         else Ypos := y0 * keisu - dia / 2 * scale * keisu;
      //̂ODTʒu
      if stype and 2 = 2 then PCIRCLE(Xpos, Ypos, dia / 2 * scale * keisu, 0 , pi)
                         else PCIRCLE(Xpos, Ypos, dia / 2 * scale * keisu, 0 , pi * 2);
      pen.Style := psDashdot;
      PCENTERLINE(Xpos,Ypos,dia / 2 * scale * keisu);//S}
      pen.Style := psSolid;
      if (maked and 4 = 4) then //a@}
        begin
          pen.color := clBlack;
          moveTo(round(x0 * keisu), round(y0 * keisu + 13 * keisu));
          LineTo(round(x0 * keisu), round(y0 * keisu + 70 * keisu));
          moveTo(round(Xpos), round(y0 * keisu + 5 * keisu));
          LineTo(round(Xpos), round(y0 * keisu + 70 * keisu));
          moveTo(round(x0 * keisu), round(y0 * keisu + 65 * keisu));
          LineTo(round(Xpos), round(y0 * keisu + 65 * keisu));
          PYA(x0 * keisu,y0 * keisu + 65 * keisu, 0);
          PYA(Xpos,y0 * keisu + 65 * keisu, pi);
          LL := floatTostrF(D / 2,ffFixed,5,1);
          Leng := TextWidth(LL);
          TextOut(round(x0 * keisu - (x0 * keisu - xpos + Leng) / 2),
                                           round(y0 * keisu + 65 * keisu - 17 * keisu),LL);
          pen.color := clRed;
        end;
      //XvOvZ
      XposB := Xpos;
      YposB := Ypos;
      dashn := 0;
      non := 0;
      Repeat
        pen.Style := psSolid;
        D := D2 - (D2 - D1) / n * dashn;//a
        if stype and 1 = 1 then//sb`vZ
          begin
            //őaRC炎f̎R
            H0 := dashn * pich;
          end
          else                //sb`pvZ
          begin
            //őaRC炎f̎R
            H0 := pi * pq * dashn * (D2 - (D2 - D1) * dashn / 2 / n);
          end;
        //non@= 1 ̎.5 ʒu
        if non = 0 then Xpos := x0 * keisu - D / 2 * scale * keisu
                   else Xpos := x0 * keisu + D / 2 * scale * keisu;
        if stype and 2 = 2 then
          if dashza + dia / 2 - dia * tanmengl > dia / 2 then
              YposD := H0 + dashza - dia * tanmengl + dia / 2  //RS tanmengl ͌
            else YposD := H0 + dia / 2;//RS tanmengl ͌
        if stype and 2 = 0 then YposD := dia / 2  + H0 + dashza;
        Ypos := y0 * keisu - YposD * scale * keisu;
        PCIRCLE(Xpos, Ypos, dia / 2 * scale * keisu, 0 ,pi * 2);
        if (non = 0) and (maked and 4 = 4) then //@}
          begin
            pen.color := clBlack;
            moveTo(round(Xpos - dia / 2  * scale * keisu), round(Ypos));
            LineTo(round(XposS), round(Ypos));
            moveTo(round(XposS + 10 * keisu), round(YposS));
            LineTo(round(XposS + 10 * keisu), round(Ypos));
            PYA(XposS + 10 * keisu, Ypos, pi / 2);
            LL := floatTostrF(YposD,ffFixed,5,1);
            Leng := TextWidth(LL);
            TextOut(round(xposS) - Leng,round(Ypos - 7 * keisu),LL);
            YposS := Ypos;
            pen.color := clRed;
          end;
        if (non = 1) and (maked and 4 = 4) then //@}
          begin
            pen.color := clBlack;
            moveTo(round(Xpos + dia / 2  * scale * keisu), round(Ypos));
            LineTo(round(XposE), round(Ypos));
            moveTo(round(XposE - 10 * keisu), round(YposE));
            LineTo(round(XposE - 10 * keisu), round(Ypos));
            PYA(XposE - 10 * keisu, Ypos, pi / 2);
            LL := floatTostrF(YposD,ffFixed,5,1);
            TextOut(round(xposE),round(Ypos - 7 * keisu),LL);
            YposE := Ypos;
            pen.color := clRed;
          end;
        if (dashn = 0) and (maked and 4 = 4) then //a@}
          begin
            pen.color := clBlack;
            moveTo(round(Xpos),round(Ypos + Dia /2 * scale * keisu + 5 * keisu));
            LineTo(round(Xpos), round(y0 * keisu + 50 * keisu));
            moveTo(round(x0 * keisu), round(y0 * keisu + 45 * keisu));
            LineTo(round(Xpos), round(y0 * keisu + 45 * keisu));
            PYA(x0 * keisu,y0 * keisu + 45 * keisu, pi);
            PYA(Xpos,y0 * keisu + 45 * keisu, 0);
            LL := floatTostrF(D / 2,ffFixed,5,1);
            Leng := TextWidth(LL);
            TextOut(round(x0 * keisu - (x0 * keisu - xpos + Leng)/2),
                                           round(y0 * keisu + 45 * keisu - 17  * keisu),LL);
            pen.color := clRed;
          end;
        dashn := dashn + dashk;//Z
        if non = 0  then
          begin
            non := 1;
            QL := ArcTan((YposB - Ypos)/(Xpos - XposB));//ڐpx
            Lx0 := round(XposB - dia / 2 * sin(QL) * scale * keisu);
            Ly0 := round(YposB - dia / 2 * cos(QL) * scale * keisu);
            Lx1 := round(Xpos - dia / 2 * sin(QL) * scale * keisu);
            Ly1 := round(Ypos - dia / 2 * cos(QL) * scale * keisu);
            //aC㑤
            MoveTo(Lx0, Ly0);
            LineTo(Lx1, Ly1);
            Lx0 := round(XposB + dia / 2 * sin(QL) * scale * keisu);
            Ly0 := round(YposB + dia / 2 * cos(QL) * scale * keisu);
            Lx1 := round(Xpos + dia / 2 * sin(QL) * scale * keisu);
            Ly1 := round(Ypos + dia / 2 * cos(QL) * scale * keisu);
            //펞aC␳
            if Ly0 > Y0 * keisu then
              begin
                if Ly1 - Ly0 <> 0 then
                Lx0 := Lx0 - round((Lx0 - Lx1) * (Y0 * keisu - Ly0) / (Ly1 - Ly0));
                Ly0 := round(Y0 * keisu);
              end;
            //aC
            MoveTo(Lx0, Ly0);
            LineTo(Lx1, Ly1);
          end
          else non := 0;

        if (n < dashn) and (maked and 4 = 4) then //㑤a@}
          begin
            pen.color := clBlack;
            moveTo(round(x0 * keisu),round(y0 * keisu - fh0 * scale * keisu - 13 * keisu));
            LineTo(round(x0 * keisu),round(y0 * keisu - fh0 * scale * keisu - 50 * keisu));
            moveTo(round(Xpos),round(Ypos - Dia /2 * scale * keisu - 5 * keisu));
            LineTo(round(Xpos),round(y0 * keisu - fh0 * scale * keisu - 50 * keisu));
            moveTo(round(x0 * keisu),round(y0 * keisu - fh0 * scale * keisu - 45 * keisu));
            LineTo(round(Xpos),round(y0 * keisu - fh0 * scale * keisu - 45 * keisu));
            if non = 0  then
              begin
                PYA(x0 * keisu, y0 * keisu - fh0 * scale * keisu - 45 * keisu, 0);
                PYA(Xpos, y0 * keisu - fh0 * scale * keisu - 45 * keisu, pi);
              end
              else
              begin
                PYA(x0 * keisu, y0 * keisu - fh0 * scale * keisu - 45 * keisu, pi);
                PYA(Xpos, y0 * keisu - fh0 * scale * keisu - 45 * keisu, 0);
              end;
            LL := floatTostrF(D / 2,ffFixed,5,1);
            Leng := TextWidth(LL);
            TextOut(round(x0 * keisu - (x0 * keisu - xpos + Leng) / 2),
                            round(y0 * keisu - fh0 * scale * keisu - 45 * keisu - 17 * keisu),LL);
            pen.color := clRed;
          end;
        pen.Style := psdashdot;
        PCENTERLINE(Xpos,Ypos,dia / 2 * scale * keisu);//S}
        XposB := Xpos;
        YposB := Ypos;
      until n < dashn;
      pen.Style := psSolid;
      //@non@= 0@̎@ODT
      if non = 1 then Xpos := x0 * keisu + (Ri + D / 2) / 2 * scale * keisu
                 else Xpos := x0 * keisu - (Ri + D / 2) / 2 * scale * keisu;
      if stype and 2 = 2 then Ypos := y0 * keisu - fh0 * scale * keisu
                         else Ypos := y0 * keisu - (dia / 2  + (H0 + dashza * 2)) * scale * keisu;
      //ӍODT̈ʒu
      if stype and 2 = 2 then PCIRCLE(Xpos, Ypos, dia / 2 * scale * keisu, pi ,pi * 2)
                         else PCIRCLE(Xpos, Ypos, dia / 2 * scale * keisu, 0 ,pi * 2);
      pen.Style := psDashdot;
      PCENTERLINE(Xpos,Ypos,dia / 2 * scale * keisu);//S}
      pen.Style := psSolid;
      if maked and 4 = 4 then //㑤a@}ӍODT
        begin
          pen.color := clBlack;
          moveTo(round(Xpos),round(y0 * keisu - fh0 * scale * keisu - 5 * keisu));
          LineTo(round(Xpos),round(y0 * keisu - fh0 * scale * keisu - 50 * keisu));
          moveTo(round(x0 * keisu),round(y0 * keisu - fh0 * scale * keisu - 45 * keisu));
          LineTo(round(Xpos),round(y0 * keisu - fh0 * scale * keisu - 45 * keisu));
          if non = 1  then
            begin
              PYA(x0 * keisu,y0 * keisu - fh0 * scale * keisu - 45 * keisu, 0);
              PYA(Xpos,y0 * keisu - fh0 * scale * keisu - 45 * keisu, pi);
            end
            else
            begin
              PYA(x0 * keisu,y0 * keisu - fh0 * scale * keisu - 45 * keisu, pi);
              PYA(Xpos,y0 * keisu - fh0 * scale * keisu - 45 * keisu, 0);
            end;
          LL := floatTostrF((Ri + D / 2) / 2,ffFixed,5,1);
          Leng := TextWidth(LL);
          TextOut(round(x0 * keisu - (x0 * keisu - xpos + Leng)/2),
                             round(y0 * keisu - fh0 * scale * keisu - 45 * keisu - 17 * keisu),LL);
          pen.color := clRed;
        end;

      //LODTŏIꍇ
      if non = 0 then
        begin
          QL := ArcTan((YposB - Ypos)/(Xpos - XposB));//ڐpx
          Lx0 := round(XposB - dia / 2 * sin(QL) * scale * keisu);
          Ly0 := round(YposB - dia / 2 * cos(QL) * scale * keisu);
          Lx1 := round(Xpos - dia / 2 * sin(QL) * scale * keisu);
          Ly1 := round(Ypos - dia / 2 * cos(QL) * scale * keisu);
          //펞aC␳㑤̐
          if Ly1 < Y0 * keisu - fh0 * scale * keisu then
            begin
              if Ly1 - Ly0 <> 0 then
                  Lx1 := Lx0-round((Lx0-Lx1) * (Ly0 - (Y0 - fh0 * scale)* keisu) / (Ly0 - Ly1));
              Ly1 := round(Y0 * keisu - fh0 * scale * keisu);
            end;
          MoveTo(Lx0, Ly0);
          LineTo(Lx1, Ly1);
          Lx0 := round(XposB + dia / 2 * sin(QL) * scale * keisu);
          Ly0 := round(YposB + dia / 2 * cos(QL) * scale * keisu);
          Lx1 := round(Xpos + dia / 2 * sin(QL) * scale * keisu);
          Ly1 := round(Ypos + dia / 2 * cos(QL) * scale * keisu);
          MoveTo(Lx0, Ly0);
          LineTo(Lx1, Ly1);
        end;
      XposB := Xpos;
      YposB := Ypos;

      //Ӎ1̈ʒu

      if non = 1 then Xpos := x0 * keisu - Ri * scale * keisu
                 else Xpos := x0 * keisu + Ri * scale * keisu;
      if stype and 2 = 2 then Ypos := y0 * keisu - (fh0 + (tanmengl - 0.5) * dia) * scale * keisu
                         else Ypos := y0 * keisu - (dia / 2  + (H0 + dashza * 2)) * scale * keisu;
      if stype and 2 = 2 then PCIRCLE(Xpos, Ypos, dia / 2 * scale * keisu,
                             pi + ArcSin((tanmengl - 0.5) / 0.5), pi * 2 - ArcSin((tanmengl - 0.5)) / 0.5)
                         else
                         begin
                          PCIRCLE(Xpos, Ypos, dia / 2 * scale * keisu, 0, pi * 2);
                          pen.Style := psDashdot;
                          PCENTERLINE(Xpos,Ypos,dia / 2 * scale * keisu);//S}
                         end;
      pen.Style := psSolid;
      if maked and 4 = 4 then //㑤a@}Ӎ1
        begin
          pen.color := clBlack;
          moveTo(round(Xpos),round(y0 * keisu - fh0 * scale * keisu - 5 * keisu));
          LineTo(round(Xpos),round(y0 * keisu - fh0 * scale * keisu - 30 * keisu));
          moveTo(round(x0 * keisu),round(y0 * keisu - fh0 * scale * keisu - 25 * keisu));
          LineTo(round(Xpos),round(y0 * keisu - fh0 * scale * keisu - 25 * keisu));
          if non = 0  then
            begin
              PYA(x0 * keisu,y0 * keisu - fh0 * scale * keisu - 25 * keisu, 0);
              PYA(Xpos,y0 * keisu - fh0 * scale * keisu - 25 * keisu, pi);
            end
            else
            begin
              PYA(x0 * keisu,y0 * keisu - fh0 * scale * keisu - 25 * keisu, pi);
              PYA(Xpos,y0 * keisu - fh0 * scale * keisu - 25 * keisu, 0);
            end;
          LL := floatTostrF(Ri,ffFixed,5,1);
          Leng := TextWidth(LL);
          TextOut(round(x0 * keisu - (x0 * keisu - xpos + Leng)/2),
                            round(y0 * keisu - fh0 * scale * keisu - 25 * keisu - 17 * keisu),LL);
          pen.color := clRed;
        end;

      //LŏIꍇ
      if non = 1 then
        begin
          //LŏIꍇ̐aC
          QL := ArcTan((YposB - Ypos)/(Xpos - XposB));//ڐpx
          Lx0 := round(XposB + dia / 2 * sin(QL) * scale * keisu);
          Ly0 := round(YposB + dia / 2 * cos(QL) * scale * keisu);
          Lx1 := round(Xpos + dia / 2 * sin(QL) * scale * keisu);
          Ly1 := round(Ypos + dia / 2 * cos(QL) * scale * keisu);
          MoveTo(Lx0, Ly0);
          LineTo(Lx1, Ly1);
          //LŏIꍇ̏ӃC
          Ypos := y0 * keisu - fh0 * scale * keisu;
          if stype and 2 = 2 then Xpos := (Ri + dia / 2) * scale * keisu
                             else Xpos := Ri * scale * keisu;
          MoveTo(round(x0 * keisu - Xpos), round(Ypos));
          if stype and 2 = 2 then Xpos := ((Ri + D / 2) / 2 + dia / 2) * scale * keisu
                             else Xpos := (Ri + D / 2) / 2 * scale * keisu;
          LineTo(round(x0 * keisu + Xpos), round(Ypos));
        end
        else
        //L0.5ŏIꍇ̏ӃC aC͖
        begin
          Ypos := y0 * keisu -  fh0 * scale * keisu;
          if stype and 2 = 2 then Xpos := (Ri + dia / 2) * scale * keisu
                             else Xpos := Ri * scale * keisu;
          MoveTo(round(x0 * keisu + Xpos), round(Ypos));
          if stype and 2 = 2 then Xpos := ((Ri + D / 2) / 2 + dia / 2) * scale * keisu
                             else Xpos := (Ri + D / 2) / 2 * scale * keisu;
          LineTo(round(x0 * keisu - Xpos), round(Ypos));
        end;
      if maked and 4 = 4 then //@}
        begin
          pen.color := clBlack;
          moveTo(round(x0 * keisu - Xpos - 5 * keisu), round(Ypos));
          LineTo(round(XposS), round(Ypos));
          moveTo(round(XposS + 10 * keisu), round(YposS));
          LineTo(round(XposS + 10 * keisu), round(Ypos));
          PYA(XposS + 10 * keisu, Ypos, pi / 2);
          LL := floatTostrF(fh0,ffFixed,5,1);
          Leng := TextWidth(LL);
          TextOut(round(xposS) - Leng,round(Ypos - 7 * keisu),LL);
        end;
    end;
    printoutdata; //vZʏo
    NewPage;
    printoutQuality;//olOto

    EndDoc;
  end;
end;

end.
